 /*
 * mspotlight.sl
 * light Shader
 * based on mmshdspt.sl
 * Generated by SDE for project 3dto3d
 * thomas.baier@stmuc.com
 */

light
mspotlight( 
    float  intensity = 1;
    color  lightcolor = 1;
    point  from = point "shader" (0,0,0);	/* light position */
    point  to = point "shader" (0,0,1);
    float  coneangle = radians(30);
    float  conedeltaangle = radians(5);
    float  beamdistribution = 2;
    string shadowname = "";
    float samples = 16;
    float width = 1;
)
{
    float atten;
    float cosangle;
    uniform point A = (to - from) / length(to - from);
    uniform float cosoutside = cos(coneangle);
    uniform float cosinside = cos(coneangle-conedeltaangle);

    illuminate( from, A, coneangle ) 
    {
	cosangle = L.A / length(L);
	atten = pow(cosangle, beamdistribution);
	atten *= smoothstep( cosoutside, cosinside, cosangle );
	if (shadowname != "") 
	{
		atten *= 1-shadow(shadowname, Ps, "samples", samples,
			"swidth", width, "twidth", width);
	}
	Cl = atten * intensity * lightcolor;
    }
}
