/*
 * sh3dto3d.sl
 * surface Shader
 * Generated by SDE for project 3dto3d
 * copyright by thomas.baier@stmuc.com
 */

#define blend(a,b,x) ((a) * (1 - (x)) + (b) * (x))

surface
sh3dto3d ( 
  float Ka = 0.7;
  float Kd = 1.0;
  float Ks = 0.5; 
  float roughness = .1;
  color specularcolor = 1;

//  string texturemap1 = "default.tif";
  string texturemap1 = "";
  float t1_value = 0.0;
  float t1_u = 1.0;
  float t1_v = 1.0;
//  string texturemask1 = "mask.tif";
  string texturemask1 = "";
  float m1_value = 0.0;
  float m1_u = 1.0;
  float m1_v = 1.0;

//  string texturemap2 = "mask.tif";
  string texturemap2 = "";
  float t2_value = 0.0;
  float t2_u = 1.0;
  float t2_v = 1.0;
//  string texturemask2 = "mask.tif";
  string texturemask2 = "";
  float m2_value = 0.0;
  float m2_u = 1.0;
  float m2_v = 1.0;

//  string opacitymap = "default.tif";
  string opacitymap = "";
  float to_value = 0.0;
  float ot_u = 1.0;
  float ot_v = 1.0;
//  string opacitymask = "mask.tif";
  string opacitymask = "";
  float mo_value = 0.0;
  float om_u = 1.0;
  float om_v = 1.0;
)
{
  normal Nf;
  vector V;

  color Ct1;
  color Cm1;
  color Ct2;
  color Cm2;
  color Ct4;
  color Cm4;

  color texture1;
  color texture2;
  color texture4;

  color layer0;
  color layer1;
  color mix1;
  color layer2;
  color mix2;

  color opacity0;
  color opacity1;
  color mix4;

/* texture1 */
  if (texturemap1 != "")
  {
         Ct1 = color texture (texturemap1, t1_u * s, t1_v * t);
  }  
  else 
  {
        Ct1 = 1;
        t1_value = 0.0;  	
  }
  if (texturemask1 != "")
  {
         Cm1 = color texture (texturemask1, m1_u * s, m1_v * t);
  }  
  else 
  {
        Cm1 = 1;
        m1_value = 0.0;  	
  }

/* texture 2 */
  if (texturemap2 != "")
  {
         Ct2 = color texture (texturemap2, t2_u * s, t2_v * t);
  }  
  else 
  {
        Ct2 = 1;
        t2_value = 0.0;  	
  }
  if (texturemask2 != "")
  {
         Cm2 = color texture (texturemask2, m2_u * s, m2_v * t);
  }  
  else 
  {
        Cm2 = 1;
        m2_value = 0.0;  	
  }

/* opacity */
  if (opacitymap != "")
  {
         Ct4 = color texture (opacitymap, ot_u * s, ot_v * t);
  }  
  else 
  {
        Ct4 = 1;
        to_value = 0.0;  	
  }
  if (opacitymask != "")
  {
         Cm4 = color texture (opacitymask, om_u * s, om_v * t);
  }  
  else 
  {
        Cm4 = 1;
        mo_value = 0.0;  	
  }

  opacity0 = Os;
  layer0 = Cs;

/* Texture 1 */
  if(t1_value > 0.0 )
  {
    texture1 = (Ct1 - blend(0, (1 - Cm1), m1_value));
    mix1      = blend( texture1, layer0, (1 - Cm1) * m1_value);
    if(m1_value == 0)
       layer1 = blend(layer0,  texture1, t1_value );
    else
       layer1 = blend(layer0,  mix1, t1_value );
  }
  else
    layer1 = layer0;

/* Texture 2 */
  if(t1_value > 0.0 )
  {
    texture2 = (Ct2 - blend(0, (1 - Cm2), m2_value));
    mix2    = blend( texture2, layer0, (1 - Cm2) * m2_value);
    if(m2_value == 0)
       layer2 = blend(layer1,  texture2, t2_value );
    else
       layer2 = blend(layer1,  mix2, t2_value );
  }
  else
    layer2 = layer1;
      
/* Opacity */
/*
  texture4 = (Ct4 - blend(0, (1 - Cm4), mo_value));
  mix4    = blend( texture4, opacity0, (1 - Cm4) * mo_value);
  if(mo_value == 0)
     opacity1 = blend(opacity0,  texture4, to_value );
  else
     opacity1 = blend(opacity0,  mix4, to_value );
*/

  Nf = faceforward (normalize(N),I);
  V = -normalize(I);

/* Opacity */
//  Oi = 1 - opacity1;
  if(to_value > 0.0)
    Oi = (1 - Ct4) * to_value;
  else
   Oi = Os;

/* Surface Color */
   Ci = Os * ( layer2 * (Ka*ambient() + Kd*diffuse(Nf)) +
	      specularcolor * Ks*specular(Nf,V,roughness));

}
